# webpack-unused-find

A webpack plugin to find unused modules/source files and remove them.


## Install

```
npm i webpack-unused-find -s
```

## Usage

vue.config.js中配置
```javascript
module.exports = {
  configureWebpack: config => {
    const UnusedFind = require('webpack-unused-find/plugin')
    config.plugins.push(new UnusedFind())
  }
}
```

package.json中配置
```
"scripts": {
    "used-find": "vue-cli-service build --used-find",
    "unused-find": "unused-find --dir=src --exceed=src/assets/svg/ --exceed=src/style/ --html"
}
```

步骤1：执行used-find指令，生成use-list.txt文件
步骤2：执行unused-find指令，和use-list.txt进行比对，生成最终文件unused-list文件，根据此文件进行无用文件的删除

## Options
- `--used-find` : 判断是否执行有效文件搜索
- `--dir=src` : 设置对src文件夹下所有文件路径的输出
- `--exceed=src/assets/svg/` : 设置对无用文件列表中路径为src/assets/svg/进行过滤操作
- `--html` : 无用文件列表生成的文件类型为html，不设置则默认原样输出