const pluginName = 'UnusedFindPlugin'
const fs = require('fs')
const MD5 = require('md5-node')
const { processArgv } = require('./utils/getProcessArg')
const { useFileName } = require('./utils/getFileName')

let pathSet = new Set()

function takeQuery (path) {
  let arr = path.split('?')
  return arr[0]
}

function savePath (path) {
  path = takeQuery(path)
  let key = MD5(path)
  if (pathSet.has(key)) {
    return
  }
  pathSet.add(key)
  fs.appendFileSync(`${useFileName}.txt`, `${path}\n`, 'utf-8')
}

class UnusedFind {
  handleBuildModule (module) {
    const { userRequest } = module
    if (!userRequest) {
      return
    }
    const rawRequest = userRequest.replace(process.cwd(), '')
    if (rawRequest.includes('node_modules')) {
      return
    }
    //console.log(rawRequest)

    savePath(rawRequest)
  }

  apply (compiler) {
    let argv = processArgv()
    if (argv.includes('--used-find')) {
      compiler.hooks.compilation.tap(
        pluginName,
        compilation => {
          compilation.hooks.buildModule.tap(
            pluginName,
            this.handleBuildModule.bind(this)
          )
        })
    }
  }
}

module.exports = UnusedFind
